//+------------------------------------------------------------------+
//|                                                   LarryTrend.mq4 |
//|  c Larry   Slope Direction Line by iGoR AKA FXiGoR|
//|    ,         30.08.2009    |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#property indicator_chart_window

//            .
//    ,         . 
// The dotted ray means that the trend isn't confirmed by a size of alligators mouth and the price.

extern string _1_   =  " ()"; 
extern string TRray =  "LarryTrendRay";
extern int period   =  50; //      , bars
extern int imode    =  3;  //     ( 3).  mode
extern color colup  =  Blue;
extern color coldn  =  Red;
extern color colfl  =  Gold;
extern string _FlatZone   =  "  0     .   ";
extern int flzone   =  20; //     . flatzone in degr. (+/- 36)
extern int allzone  =  8;  // .    . (flat. min size of alligators mouth in pips)
extern int inibar   =  3; //      (draw from #bars)
extern int endbar   =  1; //      ( to #bar)
double iitr1,iitr3;
datetime iitt1,iitt3;
color ray;
datetime ttr[];
double vect[],itrend[];
double cnnl;
//----------------------------------------------------------------------------------------
int deinit()
  {ObjectDelete(TRray); return(0);}
//----------------------------------------------------------------------------------------
int start()
  {itrend(); return(0);}
//=============================================================================
double WMA(int x, int p) 
{return(iMA(NULL, 0, p, 0, imode, PRICE_CLOSE, x));} 

//-------------------------------------------------------------

void trendarr()
{
int e ; 
int x = 0; 
int p = MathSqrt(period); 

int IBARS = iBars(NULL, 0);
static int IndCounted;
int MaxBar, bar, counted_bars = IndCounted;
IndCounted = IBARS - 1;
e = IBARS - counted_bars + period ;
MaxBar = IBARS - 1 - period;

if(e > MaxBar) e = MaxBar;

ArraySetAsSeries(vect, false);
ArrayResize(vect, IBARS); 
ArraySetAsSeries(vect, true);
ArraySetAsSeries(itrend, false);
ArrayResize(itrend, IBARS); 
ArraySetAsSeries(itrend, true);
ArraySetAsSeries(ttr, false);
ArrayResize(ttr, IBARS); 
ArraySetAsSeries(ttr, true);

for(x = 0; x < e; x++)vect[x] = 2*WMA(x, period/2) - WMA(x, period);

for(x = 0; x < e; x++)
    {itrend[x] = iMAOnArray(vect, 0, p, 0, imode, x);
      ttr[x]=Time[x];
    }
} 
//--------------------------------------------------------------
void SETTRray(string nm,datetime t1, double p1, datetime t2, double p2,int st=0, int wd=1, color cl=Red)
{ 
if (ObjectFind(nm)<0) ObjectCreate(nm,OBJ_TRENDBYANGLE,0,0,0);
  ObjectSet(nm, OBJPROP_TIME1, t1);
  ObjectSet(nm, OBJPROP_PRICE1, p1);
  ObjectSet(nm, OBJPROP_TIME2, t2);
  ObjectSet(nm, OBJPROP_PRICE2, p2);
  ObjectSet(nm, OBJPROP_COLOR , cl);
  ObjectSet(nm, OBJPROP_STYLE , st);
  ObjectSet(nm, OBJPROP_WIDTH , wd);
}
//--------------------------------------------------------------------------------------------
void itrend()
{
trendarr();
int rstyle,rwd;
string commangle;
   if (inMA()) {rstyle=0; rwd=2;}
      else {rstyle=1; rwd=1;}

double iangle=ObjectGet(TRray,OBJPROP_ANGLE);
double i1=NormalizeDouble(itrend[endbar],Digits);
double i3=NormalizeDouble(itrend[inibar],Digits);
datetime itt1=ttr[endbar];
datetime itt3=ttr[inibar];

if (iangle>flzone && iangle<90) {ray=colup; commangle=DoubleToStr(iangle,0)+" ";}
   else if (iangle>270 && iangle<(360-flzone)) {ray=coldn; commangle=DoubleToStr(iangle-360,0)+" ";}
      else {ray=colfl; commangle="- Flat...";}


if(ObjectFind(TRray)==0)
   {if(ObjectGet(TRray,OBJPROP_PRICE1)==i1 && ObjectGet(TRray,OBJPROP_PRICE2)==i3) return;}


iitr1=i1;
iitr3=i3;
iitt1=itt1;
iitt3=itt3;



ObjectDelete(TRray); 
SETTRray(TRray,iitt3,iitr3,iitt1,iitr1,rstyle,rwd,ray);
Comment( "Flatzone ",flzone,"  and ",allzone," pp.","\nTrend angle  ",commangle,"\nAlligator size ",DoubleToStr(cnnl,0)," pp."); 
WindowRedraw();
 
}
//===============================================================================================

bool inMA () 
{
double marr13, marr8, marr5, marr3, v_max,v_min;

marr13    = iMA(NULL,0,13,0,MODE_SMMA,PRICE_MEDIAN,0);
marr8     = iMA(NULL,0,8,0,MODE_SMMA,PRICE_MEDIAN,0);
marr5     = iMA(NULL,0,5,0,MODE_SMMA,PRICE_MEDIAN,0);
marr3     = iMA(NULL,0,2,0,MODE_SMMA,PRICE_MEDIAN,0);

v_min=MathMin( marr8, MathMin( marr5, marr13)); 
v_max=MathMax( marr8, MathMax( marr5, marr13)); 



cnnl=(v_max-v_min)/Point;

if (cnnl>allzone && ((ray==colup && marr3>v_max && marr8>marr13) || (ray==coldn && marr3<v_min && marr8<marr13))) return(True);
   else return(False);
}  
 